//**************************************************************
// WILDCAT GRAV CYCLE
//**************************************************************
//**************************************************************
// SOUNDS
//**************************************************************
datablock EffectProfile(ScoutEngineEffect)
{
   effectname = "vehicles/outrider_engine";
   minDistance = 5.0;
   maxDistance = 10.0;
};

datablock EffectProfile(ScoutThrustEffect)
{
   effectname = "vehicles/outrider_boost";
   minDistance = 5.0;
   maxDistance = 10.0; //Zengei - was: 10.0
};

datablock AudioProfile(ScoutSqueelSound)
{
   filename    = "fx/vehicles/outrider_skid.wav";
   description = ClosestLooping3d;
   preload = true;
};

// Scout
datablock AudioProfile(ScoutEngineSound)
{
   filename    = "fx/vehicles/outrider_engine.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   effect = ScoutEngineEffect;
};

datablock AudioProfile(ScoutThrustSound)
{
   filename    = "fx/vehicles/outrider_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   effect = ScoutThrustEffect;
};

//**************************************************************
// LIGHTS
//**************************************************************
datablock RunningLightData(WildcatLight1)
{
   radius = 1.0;
   color = "1.0 1.0 1.0 0.3";
   nodeName = "Headlight_node01";
   direction = "-1.0 1.0 0.0";
   texture = "special/headlight4";
};

datablock RunningLightData(WildcatLight2)
{
   radius = 1.0;
   color = "1.0 1.0 1.0 0.3";
   nodeName = "Headlight_node02";
   direction = "1.0 1.0 0.0";
   texture = "special/headlight4";
};

datablock RunningLightData(WildcatLight3)
{
   type = 2;
   radius = 100.0;
   color = "1.0 1.0 1.0 1.0";
   offset = "0.0 0.0 0.0";
   direction = "0.0 1.0 0.0";
   texture = "special/projheadlight";
};

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock HoverVehicleData(ScoutVehicle) : WildcatDamageProfile
{
   spawnOffset = "0 0 1";

   floatingGravMag = 3.5;

   catagory = "Vehicles";
   shapeFile = "tac_vehicle_grav_scout.dts";
   computeCRC = true;

   debrisShapeName = "debris_generic.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag = 0.0;
   density = 0.9;

   mountPose[0] = scoutRoot;
   cameraMaxDist = 5.0;
   cameraOffset = 0.7;
   cameraLag = 0.5;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;
   explosion = SExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   lightOnly = 1;

   maxDamage = 0.325; //Zengei - was: 1.00
   destroyedLevel = 0.325; //Zengei - was: 1.00

   isShielded = false;
   rechargeRate = 0.1; //Zengei - was: 0.8
   energyPerDamagePoint = 60;
   maxEnergy = 150;
   
   //Zengei - this is the afterburner stuff
   jetForce = 0; //Zengei - didn't exist before
   minJetEnergy = 150; //Zengei - was: 15, the AB can only be used when energy is at its maximum
   jetEnergyDrain = 8.5; //Zengei - was: 1.1
   turboFactor = 7.5; //Zengei - was: 1.5

   // Rigid Body
   mass = 80;
   bodyFriction = 0.1;
   bodyRestitution = 0.5;
   softImpactSpeed = 50;       // Play SoftImpact Sound
   hardImpactSpeed = 250;      // Play HardImpact Sound //Zengei - was: 150

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 250; //Zengei - was: 150
   speedDamageScale = 0.006;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 23;
   collDamageMultiplier   = 0.035;

   dragForce            = 21.0 / 45.0; //Zengei - was: 25 / 45.0
   vertFactor           = 0.0;
   floatingThrustFactor = 1;

   mainThrustForce    = 21.25; //Zengei - was: 17
   reverseThrustForce = 4; //Zengei - was: 4
   strafeThrustForce  = 8; //Zengei - was: 4

   brakingForce = 0.1;
   brakingActivationSpeed = 4;

   stabLenMin = 2.25;
   stabLenMax = 3.25;
   stabSpringConstant  = 30;
   stabDampingConstant = 12;

   gyroDrag = 36; //ZENGEI - WAS: 18
   normalForce = 30;
   restorativeForce = 30;
   steeringForce = 10; //Zengei - was: 5
   rollForce  = 19;
   pitchForce = 15;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 0.5; //Zengei - was: 2.5
   dustHeight = 10.0; //Zengei - was: 1.0
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 0.6; //Zengei - was: 3.6
   dustTrailFreqMod = 150.0; //Zengei - was: 15.0

   jetSound         = ScoutSqueelSound;
   engineSound      = ScoutEngineSound;
   floatSound       = ScoutThrustSound;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 20.0;
   hardSplashSoundVelocity = 30.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterSoftSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterSoftSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeSoftSplashSound;

   minMountDist = 4;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 0.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   forwardJetEmitter = WildcatJetEmitter;

   cmdCategory = "Objectives";
   cmdIcon = CMDHoverScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_landscout_grey";
   targetNameTag = 'Wildcat';
   targetTypeTag = 'Wildcat Scout';
   sensorData = VehiclePulseSensor;

   checkRadius = 1.7785;
   observeParameters = "1 10 10";

   runningLight[0] = WildcatLight1;
   runningLight[1] = WildcatLight2;
   runningLight[2] = WildcatLight3;

   shieldEffectScale = "0.9375 1.125 0.6";
   
   //Zengei, random stuff, hoping to get waypoint to work
   hudImageNameFriendly[1] = "commander/MiniIcons/com_landscout_grey";
   hudImageNameEnemy[1] = "commander/MiniIcons/com_landscout_grey";
   hudRenderModulated[1] = true;
   hudRenderAlways[1] = true;
   hudRenderCenter[1] = true;
   hudRenderDistance[1] = true;
   hudRenderName[1] = true;
};

//**************************************************************
// WEAPONS
//**************************************************************

datablock FlareProjectileData(VehicleFlareGrenadeProj)
{
   projectileShapeName = "grenade_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = false;
   kickBackStrength    = 1500;
   useLensFlare        = false;

   fireEnergy = 50.00;

   sound 			   = FlareGrenadeBurnSound;
   explosion           = FlareGrenadeExplosion;
   velInheritFactor    = 0.5;

   texture[0]          = "special/flare3";
   texture[1]          = "special/LensFlare/flare00";
   size                = 4.0;

   baseEmitter         = FlareEmitter;

   grenadeElasticity = 0.35;
   grenadeFriction   = 0.2;
   armingDelayMS     = 6000;
   muzzleVelocity    = 15.0;
   drag = 0.1;
   gravityMod = 0.15;
};


//**************************************************************
// VEHICLE CODE
//**************************************************************

function ScoutVehicle::onAdd(%this, %obj)
{
   	Parent::onAdd(%this, %obj);
   	%obj.schedule(8000, "playThread", $ActivateThread, "activate");
}

function ScoutVehicle::onTrigger(%data, %obj, %trigger, %state)
{
	if(%trigger == 0)
	{
		switch (%state)
		{
			case 0:
					%obj.UseVehicleFlareGrenade(VehicleFlareGrenadeProj.fireEnergy);

			case 1:
		}
	}
}